# ============================================================================
# Serialized objects

SERIALIZED_OBJNAMES <- c(
    paste("chr", c(1:22, "X", "Y"), "_snplocs", sep=""),
    "SNPcount"
)


# ============================================================================
# Objects created "on-the-fly" (not serialized)

# WARNING: Improper calls to 'getdata' by the 'createObject' function can lead
# to infinite recursive loops!
createObject <- function(objname)
{
    # add more here...
    stop("don't know how to create object '", objname, "'")
}


# ============================================================================
# The 'getdata' function

datacache <- new.env(hash=TRUE, parent=emptyenv())

getdata <- function(objname)
{
    if (!exists(objname, envir=datacache)) {
        if (objname %in% SERIALIZED_OBJNAMES) {
            data(list=objname, package="SNPlocs.Hsapiens.dbSNP.20071016", envir=datacache)
        } else {
            assign(objname, createObject(objname), envir=datacache)
        }
    }
    get(objname, envir=datacache)
}

